#include <iostream>

using namespace std;

const int N=8;
const int M=N;

void Backtrack_8vezer(int,int,bool&,int[]);
void Jo_eset_kereses(int,int,const int[],bool&,int&);
bool Rossz_eset(int,int,const int[]);

int main()
{
    cout << "Backtrack - 8 vezer" << endl;

    /// deklaracio
    bool VAN;
    int X[N+1]={};

    /// fgv hivas
    Backtrack_8vezer(N,M,VAN,X);

    /// kiiratas
    if (VAN) {
        for (int i=1;i<=N;i++) {
            cout << X[i] << " ";
        }
        cout << endl;
    } else {
        cout << "NINCS MEGOLDAS" << endl;
    }

    return 0;
}

void Backtrack_8vezer(int N,int M,bool &VAN,int X[]){
	int i=1;
	int melyik;
	while ((i>=1) && (i<=N)) {
		Jo_eset_kereses(i,M,X,VAN,melyik);
		if (VAN) {
			X[i]=melyik;
			i++;
		} else {
			X[i]=0;
			i--;
        }
	}
	VAN=(i>=1);
}

void Jo_eset_kereses(int i, int M,const int X[],bool &VAN,int &melyik){
    int j=X[i]+1;
	while ((j<=M) && Rossz_eset(i,j,X)) {
		j++;
	}
	VAN=(j<=M);
	melyik=j;
}

bool Rossz_eset(int i,int j,const int X[]){
    int k=1;
	while ((k<i) && !((j==X[k]) || ((i-k)==abs(X[k]-j)))) {
		k++;
    }
	return (k<i);
}
